property spriteNum, getPDLError, myDisplayType, mySprite, myMember, myWidthAdjust, myHeightAdjust, myOffStageLoc

on getBehaviorDescription me
  return "Affichage de texte" & RETURN & RETURN & "Ce comportement permet d'afficher une chaîne donnée dans un acteur champ ou texte. " & "Utilisez ce comportement avec les comportements 'Info-bulle' et 'Hypertexte - Affichage de l'état' qui ont besoin d'un acteur champ ou texte pour afficher leurs informations. " & "Ou créez votre propre Lingo personnalisé pour afficher des informations d'exécution telles que la position de la souris." & RETURN & RETURN & "Ce comportement attend des instructions Lingo. " & "Il n'est pas actif de lui-même." & RETURN & RETURN & "Vous pouvez choisir entre deux types d'affichage : info-bulle et barre d'état." & RETURN & RETURN & "Le type d'affichage 'info-bulle' entraîne le redimensionnement de l'acteur champ ou texte de manière à accommoder le texte, et sa disparition lorsqu'il est vide. " & "Vous pouvez régler le type d'affichage des info-bulles pour qu'elles apparaissent à n'importe quel endroit de la scène, tel que sous le curseur. " & "Si aucune position n'est envoyée à l'image-objet, celle-ci apparaît alors dans le coin supérieur gauche de la scène. " & "Consultez le comportement Info-bulle pour plus d'informations." & RETURN & RETURN & "Pour afficher plusieurs lignes de texte, vous devrez utiliser des caractères de retour à la ligne pour indiquer les passages à la ligne. " & "Les images-objets info-bulles sortent de la scène lorsqu'elles ne contiennent aucun texte. " & "Il est conseillé de la placer hors de la scène avant son utilisation, au cas où elle apparaîtrait brièvement à l'écran." & RETURN & RETURN & "Le type d'affichage 'barre d'état' apparaît sur la scène de façon permanente. " & "Il n'est pas redimensionné et ne change pas de position. " & "Les informations de positionnement envoyées à cette image-objet ne sont pas prises en considération si celle-ci est réglée pour agir en tant que barre d'état. " & "Si le texte est trop long pour apparaître dans l'acteur de l'image-objet, une barre de défilement est affichée. " & "Il n'est pas nécessaire de diviser le texte à l'aide de caractères de retour à la ligne. " & "Si vous pensez qu'une barre de défilement peut être nécessaire, vérifiez que l'acteur champ ou texte est suffisamment haut pour le bon fonctionnement des flèches de défilement." & RETURN & RETURN & "Réglez la taille de la police ainsi que les autres caractéristiques de l'acteur champ ou texte pour personnaliser l'apparence du message." & RETURN & RETURN & "N'oubliez pas de donner un nom à l'acteur champ ou texte. " & "Il est possible que ce comportement le vide. " & "Director efface automatiquement les acteurs vides sans nom." & RETURN & RETURN & "Types d'acteurs autorisés :" & RETURN & "champ et texte" & RETURN & RETURN & "Paramètres :" & RETURN & "* Type d'affichage :" & RETURN & "- Info-bulle (apparaît près du curseur lors du survol)" & RETURN & "- Barre d'état (apparaît à une position fixe de façon permanente)" & RETURN & RETURN & "Méthodes publiques :" & RETURN & "* Définir le texte à afficher (et la position de l'image-objet)" & RETURN & RETURN & "Comportements associés :" & RETURN & "* Info-bulle" & RETURN & "* Etat de la source" & RETURN & "* Hypertexte - Affichage de l'état"
end

on getBehaviorTooltip me
  return "Utilisable avec les acteurs champ ou texte." & RETURN & RETURN & "Attend un message provenant d'un autre comportement ou d'un gestionnaire personnalisé pour afficher une chaîne de caractères. " & "Ce comportement est conçu pour être utilisé avec les comportements 'Info-bulle' et 'Hypertexte - Affichage de l'état' pour créer une barre d'état ou une info-bulle sous le curseur."
end

on beginSprite me
  myDisplayType = resolve(myDisplayType)
  Initialize(me)
end

on endSprite me
  mySprite.visible = 1
end

on resolve prop
  case prop of
    myDisplayType:
      choiceslist = ["barre d'état (taille et position fixes)", "info-bulle (taille et position dynamiques)"]
      lookup = [#statusbar, #tooltip]
  end case
  return lookup[findPos(choiceslist, prop)]
end

on Initialize me
  mySprite = sprite(me.spriteNum)
  myMember = mySprite.member
  if myMember.type = #field then
    myWidthAdjust = (myMember.margin + myMember.border) * 2
    myHeightAdjust = myMember.margin + (myMember.border * 2)
  else
    myWidthAdjust = 0
    myHeightAdjust = 0
  end if
  myMember.text = EMPTY
  if myDisplayType = #tooltip then
    myMember.boxType = #fixed
    myOffStageLoc = point(999, 999)
    mySprite.loc = myOffStageLoc
  end if
end

on BestRect me, theString
  myMember.rect = rect(0, 0, 8000, 0)
  myMember.text = theString
  BestRect = myMember.rect
  theLine = the number of lines in theString
  theWidth = 0
  checkedChars = 0
  repeat while theLine
    endOfLine = offset(RETURN, theString)
    if not endOfLine then
      endOfLine = the number of chars in theString + 1
      myMember.text = myMember.text & RETURN
    end if
    checkedChars = checkedChars + endOfLine
    endPoint = charPosToLoc(myMember, checkedChars)
    lineWidth = endPoint[1]
    if lineWidth > theWidth then
      theWidth = lineWidth
    end if
    delete char 1 to endOfLine of theString
    theLine = theLine - 1
  end repeat
  lastChar = myMember.char.count
  lastCharLoc = charPosToLoc(myMember, lastChar)
  theHeight = lastCharLoc[2]
  BestRect[3] = theWidth + 1
  BestRect[4] = theHeight + 1
  return BestRect
end

on GetTopLeft me, theLoc, theAlignment, memberRect
  case theAlignment of
    #bottomCenter:
      return theLoc - [memberRect.width / 2, memberRect.height]
    #bottomright:
      return theLoc - [memberRect.width, memberRect.height]
    #bottomleft:
      return theLoc - [0, memberRect.height]
    #center:
      return theLoc - [memberRect.width / 2, memberRect.height / 2]
    #topCenter:
      return theLoc - [memberRect.width / 2, 0]
    #topright:
      return theLoc - [memberRect.width, 0]
    otherwise:
      return theLoc
  end case
end

on DisplayText_Enroll me, enrollList
  if ilk(enrollList) <> #list then
    return me
  end if
  if not enrollList.count() then
    enrollList.append(me)
  else
  end if
  return enrollList
end

on DisplayText_SetText me, theString, theLoc, theAlignment
  if not stringp(theString) then
    ErrorAlert(me, #invalidString, theString)
    theString = string(theString)
  else
    case ilk(theLoc) of
      #void, #point:
      otherwise:
        ErrorAlert(me, #invalidPoint, theLoc)
        theLoc = point(0, 0)
    end case
  end if
  if (theString = EMPTY) and (myDisplayType = #tooltip) then
    mySprite.loc = myOffStageLoc
  else
    myMember.text = theString
    if myDisplayType = #tooltip then
      memberRect = BestRect(me, theString)
      myMember.rect = memberRect
    else
      memberRect = myMember.rect
    end if
    memberRect = memberRect + [0, 0, myWidthAdjust, myHeightAdjust]
    if myDisplayType = #tooltip then
      if ilk(theLoc) <> #point then
        theLoc = point(0, 0)
      end if
      theLoc = GetTopLeft(me, theLoc, theAlignment, memberRect)
      stageWidth = (the activeWindow).rect.right - (the activeWindow).rect.left
      stageHeight = (the activeWindow).rect.bottom - (the activeWindow).rect.top
      maxH = stageWidth - memberRect.width
      maxV = stageHeight - memberRect.height
      theLoc[1] = max(0, min(theLoc[1], maxH))
      theLoc[2] = max(0, min(theLoc[2], maxV))
      theLoc = theLoc + myMember.regPoint
      mySprite.loc = theLoc
    else
      lastChar = theString.char.count
      textHeight = charPosToLoc(myMember, lastChar)[2]
      if textHeight > mySprite.height then
        myMember.boxType = #scroll
      else
        myMember.boxType = #fixed
      end if
    end if
  end if
end

on DisplayText_GetReference me
  return me
end

on ErrorAlert me, theError, data
  behaviorName = string(me)
  delete word 1 of behaviorName
  delete char -30001 of behaviorName
  delete char -30001 of behaviorName
  case theError of
    #invalidString:
      if the runMode = "Author" then
        message = substituteStrings(me, "Erreur de comportement : Image ^0, Image-objet ^1" & RETURN & "Comportement ^2" & RETURN & RETURN & "Le gestionnaire 'DisplayText_SetText' ne peut pas traiter l'objet suivant comme une chaîne :" & RETURN & "^3", ["^0": the frame, "^1": me.spriteNum, "^2": behaviorName, "^3": data])
        alert(message)
      end if
    #invalidPoint:
      if the runMode = "Author" then
        message = substituteStrings(me, "Erreur de comportement : Image ^0, Image-objet ^1" & RETURN & "Comportement ^2" & RETURN & RETURN & "Le gestionnaire 'DisplayText_SetText' ne peut pas traiter l'objet suivant comme un point :" & RETURN & RETURN & "^3", ["^0": the frame, "^1": me.spriteNum, "^2": behaviorName, "^3": data])
      end if
  end case
end

on substituteStrings me, parentString, childStringList
  i = childStringList.count()
  repeat while i
    tempString = EMPTY
    dummyString = childStringList.getPropAt(i)
    replacement = childStringList[i]
    lengthAdjust = dummyString.char.count - 1
    repeat while 1
      position = offset(dummyString, parentString)
      if not position then
        parentString = tempString & parentString
        exit repeat
        next repeat
      end if
      if position <> 1 then
        tempString = tempString & parentString.char[1..position - 1]
      end if
      tempString = tempString & replacement
      delete me.char[1..position + lengthAdjust]
    end repeat
    i = i - 1
  end repeat
  return parentString
end

on isOKToAttach me, aSpriteType, aSpriteNum
  case aSpriteType of
    #graphic:
      return getPos([#field, #text], sprite(aSpriteNum).member.type) <> 0
    #script:
      return 0
  end case
end

on getPropertyDescriptionList me
  if not (the currentSpriteNum) then
    exit
  end if
  return [#myDisplayType: [#comment: "Affichage de texte se comporte en tant que :", #format: #string, #default: "barre d'état (taille et position fixes)", #range: ["barre d'état (taille et position fixes)", "info-bulle (taille et position dynamiques)"]]]
end
