property mySprite, getPDLError, myString, myDelay, myPosition, myDisplaySprite, myHideFlag, myDisplayList, myStartTicks, myDisplayFlag

on getBehaviorDescription me
  return "Info-bulle" & RETURN & RETURN & "Produit une info-bulle lorsque l'utilisateur survole l'image-objet." & RETURN & RETURN & "Remarque : ce comportement appelle le comportement 'Affichage de texte' pour afficher le message. " & "Le comportement 'Affichage de texte' doit être lié à une image-objet distincte contenant un acteur champ ou un acteur texte." & RETURN & RETURN & "Si une telle image-objet existe, elle sera automatiquement sélectionnée dans la boîte de dialogue Paramètres des comportements." & RETURN & RETURN & "Pour que l'info-bulle apparaisse dans une position donnée par rapport à l'image-objet actuelle, sélectionnez la position adéquate dans la boîte de dialogue Paramètres des comportements et vérifiez que le comportement 'Affichage de texte' associé est défini pour réagir en tant qu'info-bulle. " & "Si le comportement 'Affichage de texte' est défini pour agir en tant que barre d'état, il ignore toutes les données de positionnement et apparaît dans une position fixe." & RETURN & RETURN & "Vous pouvez choisir de faire apparaître l'info-bulle au survol ou uniquement si la souris s'attarde sur l'image-objet pendant une période donnée. " & "Vous pouvez également choisir de faire disparaître l'info-bulle lorsque l'utilisateur clique sur l'image-objet." & RETURN & RETURN & "La boîte de dialogue Paramètres du comportement dispose d'un espace limité pour la saisie du contenu de l'info-bulle. " & "Elle n'accepte pas les chaînes contenant un caractère de retour à la ligne. " & "Pour afficher une longue info-bulle consistant de plusieurs lignes de texte devant apparaître à la position de cette image-objet, vous devrez envoyer un message contenant la chaîne requise à ce comportement. " & "Par exemple :" & RETURN & RETURN & "SendSprite (1, #Tooltip_SetMessage, " & QUOTE & "Ce message consiste en" & QUOTE & "&RETURN&" & QUOTE & "deux lignes de texte" & QUOTE & ")" & RETURN & RETURN & "Cela produit le message suivant lorsque la souris survole l'image-objet 1 :" & RETURN & RETURN & "Ce message consiste en" & RETURN & "deux lignes de texte" & RETURN & RETURN & "Si l'info-bulle produite par ce comportement doit être affichée dans une barre d'état, cette étape n'est pas nécessaire. " & "Le comportement 'Affichage de texte' assure qu'une longue ligne de texte est mise à la ligne dans la barre d'état et qu'une barre de défilement apparaît si nécessaire." & RETURN & RETURN & "Types d'acteurs autorisés :" & RETURN & "tous" & RETURN & RETURN & "Paramètres :" & RETURN & "* Texte de l'info-bulle (chaîne d'une ligne)" & RETURN & "* Délai avant l'affichage de l'info-bulle (en battements)" & RETURN & "* Masquer l'info-bulle lors d'un clic sur l'image-objet ? (TRUE | FALSE)" & RETURN & "* Position de l'info-bulle par rapport à l'image-objet (non prise en compte si le comportement 'Affichage de texte' est défini pour réagir en tant que barre d'état)." & RETURN & "* Numéro de l'image-objet dans laquelle l'info-bulle doit être affichée. " & "(Le comportement 'Affichage de texte' doit être lié à cette image-objet. " & "Si l'image-objet est déplacée, une alerte vous invitera à mettre les paramètres de comportement à jour)." & RETURN & RETURN & "Méthodes publiques :" & RETURN & "* Définir le message de l'info-bulle (permet l'utilisation du caractère de retour à la ligne)" & RETURN & "* Obtenir la référence du comportement" & RETURN & RETURN & "Comportements associés :" & RETURN & "* Affichage de texte - Essentiel : doit être lié à une image-objet champ ou texte couvrant le même nombre d'images." & RETURN & RETURN & "Vous pouvez trouver le comportement 'Affichage de texte' dans Palette des bibliothèques, sous Contrôles > Affichage de texte."
end

on getBehaviorTooltip me
  return "Utilisable avec n'importe quel type d'acteur." & RETURN & RETURN & "Produit une info-bulle lorsque la souris survole l'image-objet." & RETURN & RETURN & "Ce comportement exige la disponibilité du comportement 'Affichage de texte' dans une image-objet champ ou texte pour afficher les messages qu'il produit. " & "Si aucune telle image-objet n'est disponible, une alerte apparaît (à la programmation uniquement)." & RETURN & RETURN & "Le paramètre défini pour le comportement 'Affichage de texte' associé détermine si le message de l'info-bulle apparaît dans une barre d'état ou en tant qu'affichage temporaire de l'info-bulle sur l'image-objet ou à proximité de cette image-objet."
end

on beginSprite me
  Initialize(me)
end

on prepareFrame me
  CheckStatus(me)
end

on mouseEnter me
  myStartTicks = the ticks + myDelay
end

on mouseLeave me
  myStartTicks = the maxinteger
end

on Initialize me
  mySprite = sprite(me.spriteNum)
  myMember = mySprite.member
  myDisplayList = []
  myStartTicks = the maxinteger
end

on CheckStatus me
  if myStartTicks < the ticks then
    if myHideFlag then
      if the mouseDown then
        if myDisplayFlag then
          HideTip(me)
        end if
        exit
      end if
    end if
    if myDisplayFlag then
      exit
    end if
    ShowTip(me)
  else
    if myDisplayFlag then
      HideTip(me)
    end if
  end if
end

on ShowTip me
  myDisplayFlag = 1
  case myPosition of
    "au centre au-dessus":
      theAlignment = #bottomCenter
      displayLoc = point((mySprite.left + mySprite.right) / 2, mySprite.top)
    "au centre en dessous":
      displayLoc = point((mySprite.left + mySprite.right) / 2, mySprite.bottom)
      theAlignment = #topCenter
    "en haut à gauche":
      displayLoc = point(mySprite.left, mySprite.top)
      theAlignment = #topLeft
    "en haut à droite":
      displayLoc = point(mySprite.right, mySprite.top)
      theAlignment = #topright
    "au centre":
      centerH = (mySprite.left + mySprite.right) / 2
      centerV = (mySprite.top + mySprite.bottom) / 2
      displayLoc = point(centerH, centerV)
      theAlignment = #center
    "en bas à gauche":
      displayLoc = point(mySprite.left, mySprite.bottom)
      theAlignment = #bottomleft
    "en bas à droite":
      displayLoc = point(mySprite.right, mySprite.bottom)
      theAlignment = #bottomright
    "au point d'alignement":
      displayLoc = mySprite.loc
      theAlignment = #center
    "sous la souris":
      displayLoc = the mouseLoc
      theAlignment = #center
  end case
  if not myDisplayList.count() then
    EnrollDisplaySprite(me)
  end if
  call(#DisplayText_SetText, myDisplayList, myString, displayLoc, theAlignment)
end

on HideTip me
  myDisplayFlag = 0
  if not myDisplayList.count() then
    EnrollDisplaySprite(me)
  end if
  call(#DisplayText_SetText, myDisplayList, EMPTY)
end

on EnrollDisplaySprite me
  sendSprite(myDisplaySprite, #DisplayText_Enroll, myDisplayList)
  if not myDisplayList.count() then
    sendAllSprites(#DisplayText_Enroll, myDisplayList)
    if not myDisplayList.count() then
      ErrorAlert(me, #noValidSprites, myDisplaySprite)
    else
      ErrorAlert(me, #invalidSpriteNumber, myDisplaySprite)
    end if
  end if
end

on GetDisplaySprite me
  displayScriptMember = the number of member "Affichage de texte"
  if displayScriptMember > 0 then
    displayScriptMember = member(displayScriptMember)
    repeat with theSprite = 1 to the lastChannel
      theScripts = sprite(theSprite).scriptList
      scriptCount = theScripts.count()
      repeat while scriptCount
        if theScripts[scriptCount][1] = displayScriptMember then
          return theSprite
        end if
        scriptCount = scriptCount - 1
      end repeat
    end repeat
  end if
  return the currentSpriteNum + 1
end

on Tooltip_SetMessage me, theString
  case ilk(theString) of
    #string:
    otherwise:
      return #invalidTypeError
  end case
  myString = theString
end

on Tooltip_GetReference me
  return me
end

on ErrorAlert me, theError, data
  behaviorName = string(me)
  delete word 1 of behaviorName
  delete char -30001 of behaviorName
  delete char -30001 of behaviorName
  case data.ilk of
    #void:
      data = "<void>"
    #symbol:
      data = "#" & data
  end case
  case theError of
    #invalidSpriteNumber:
      if the runMode = "Author" then
        message = substituteStrings(me, "L'image-objet ^3 n'a pas répondu à un appel #DisplayText. " & "Une autre image-objet va être utilisée. " & "Veuillez ouvrir la boîte de dialogue Paramètres du comportement et choisir l'image-objet devant servir à afficher le message d'info-bulle.", ["^0": the frame, "^1": me.spriteNum, "^2": behaviorName, "^3": data])
      end if
    #noValidSprites:
      if the runMode = "Author" then
        message = substituteStrings(me, "Erreur de comportement : Image ^0, Image-objet ^1" & RETURN & "Comportement ^2" & RETURN & "Aucune image-objet n'a répondu à un appel #DisplayText." & RETURN & "Vérifiez que le comportement '^3' est lié à un champ ou texte situé dans les mêmes images que l'image-objet ^1.", ["^0": the frame, "^1": me.spriteNum, "^2": behaviorName, "^3": "Affichage de texte"])
      end if
  end case
end

on substituteStrings me, parentString, childStringList
  i = childStringList.count()
  repeat while i
    tempString = EMPTY
    dummyString = childStringList.getPropAt(i)
    replacement = childStringList[i]
    lengthAdjust = dummyString.char.count - 1
    repeat while 1
      position = offset(dummyString, parentString)
      if not position then
        parentString = tempString & parentString
        exit repeat
        next repeat
      end if
      if position <> 1 then
        tempString = tempString & parentString.char[1..position - 1]
      end if
      tempString = tempString & replacement
      delete me.char[1..position + lengthAdjust]
    end repeat
    i = i - 1
  end repeat
  return parentString
end

on isOKToAttach me, aSpriteType
  return aSpriteType = #graphic
end

on getPropertyDescriptionList me
  displaySprite = GetDisplaySprite(me)
  return [#myString: [#comment: "Texte de l'info-bulle", #format: #string, #default: "Insérez une ligne d'info-bulle dans cet espace"], #myDelay: [#comment: "Délai avant l'affichage de l'info-bulle (battements) :", #format: #integer, #range: [#min: 0, #max: 120], #default: 30], #myHideFlag: [#comment: "Masquer l'info-bulle lors d'un clic sur l'image-objet ?", #format: #boolean, #default: 1], #myPosition: [#comment: "Position de l'info-bulle p/r à l'image-objet (voir notes) :", #format: #string, #range: ["au centre au-dessus", "en haut à gauche", "en haut à droite", "au centre", "en bas à gauche", "en bas à droite", "au centre en dessous", "au point d'alignement", "sous la souris"], #default: "au centre"], #myDisplaySprite: [#comment: "Image-objet dans laquelle l'info-bulle doit être affichée :", #format: #integer, #range: [#min: 1, #max: the lastChannel], #default: displaySprite]]
end
